<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css"
        integrity="sha384-xOolHFLEh07PJGoPkLv1IbcEPTNtaed2xpHsD9ESMhqIYd0nLMwNLD69Npy4HI+N" crossorigin="anonymous">
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.10.5/font/bootstrap-icons.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="preconnect" href="https://fonts.googleapis.com">
    <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
    <link href="https://fonts.googleapis.com/css2?family=Squada+One&display=swap" rel="stylesheet">
    <link rel="stylesheet" href="style.css">
    <!-- data table -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.13.4/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.13.4/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.13.4/js/dataTables.bootstrap4.min.js"></script>
    <title>Admin</title>
</head>

<body>
    <div class="container">
        <div class="title text-center">
            <h4>DANH SÁCH ĐƠN HÀNG</h3>
        </div>
        <table id="order-table" class="table table-bordered table-primary table-hover table-striped">
            <thead class="">
                <tr>
                    <td>STT</td>
                    <td>Mã đơn hàng</td>
                    <td>Họ và tên</td>
                    <td>Payment Method</td>
                    <td>Số lượng sản phẩm</td>
                    <td>Tổng tiền</td>
                    <td>Ngày đặt hàng</td>
                    <td>Action</td>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>

</body>
<script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    $(document).ready(function () {
        const gBASE_URL = "https://food-ordering-fvo9.onrender.com/api";

        const gNAME_COL = ["STT", "orderCode", "firstName", "lastName", "methodPayment", "foods", "price", "date", "action"]
        const gSTT_COL = 0;
        const gODER_CODE_COL = 1;
        const gFIRST_NAME_COL = 2;
        const gLAST_NAME_COL = 3;
        const gPAYMENT_METHOD_COL = 4;
        const gQUANTITY_COL = 5;
        const gPRICE_COL = 6;
        const gDATE_COL = 7;
        const gACTION_COL = 8;
        var gSTT = 0;
        var gOderDataTable = $("#order-table").DataTable({
            columns: [
                { data: 'id' },
                { data: 'orderCode' },
                { data: { firstName: "firstName", lastName: "lastName" } },
                { data: 'methodPayment' },
                { data: 'foods' },
                { data: 'foods' },//tổng tiền
                { data: 'createdAt' },
                { data: 'action' }
            ],
            columnDefs: [
                {
                    targets: 0,
                    render: renderSTT
                },
                {
                    targets: 2,
                    render: renderFullname
                },
                {
                    targets: 4,
                    render: renderQuantity
                },
                {
                    targets: 5,
                    render: renderPrice
                },
                {
                    targets: 7,
                    defaultContent: `
            <img class="edit-order" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
            <img class="delete-order" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
            `
                }

            ]
        });
        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
        //thực thi sự kiện load trang:
        onPageLoading();
        //hàm thực thi nút ấn edit btn
        $("#order-table").on("click", ".edit-order", function() {
            onBtnEditOderClick(this);
        });

        //hàm thực thi nút ấn delete btn
        $("#order-table").on("click", ".delete-order", function() {
            onBtnDeleteOderClick(this);
        });
        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        //hàm sự kiện load trang
        function onPageLoading() {
            callApiToGetOrderList()
        };
        //hàm ấn nút edit order:
        function onBtnEditOderClick(paramEditBtn) {
            var vTableRow = $(paramEditBtn).parents("tr");
            var vDataTableRow = gOderDataTable.row(vTableRow);
            var vOrderId = vDataTableRow.data().id
            console.log(vOrderId)
        };

         //hàm ấn nút delete order:
         function onBtnDeleteOderClick(paramEditBtn) {
            var vTableRow = $(paramEditBtn).parents("tr");
            var vDataTableRow = gOderDataTable.row(vTableRow);
            var vOrderId = vDataTableRow.data().id
            console.log(vOrderId)
        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        //hàm gọi api lấy danh sách order:
        //hàm render STT:
        function renderSTT() {
            gSTT++
            return gSTT
        };

        function renderFullname(paramArr) {
            return `${paramArr.firstName} ${paramArr.lastName}`
        }

        function renderQuantity(paramFoodArr) {
            return paramFoodArr.length;
        }
        // function renderPrice(paramFoodsArr) {
        //     var vTotal = 0;
        //     for (var paramFoodsArr of paramFoodsArr) {
        //         vTotal += paramFoodsArr.price
        //     }

        //     return vTotal
        // }
        // function renderPrice(paramFoodsArr) {
        //     var vTotal = 0;
        //     for (var bI = 0; bI < paramFoodsArr.length; bI++) {
        //         vTotal += paramFoodsArr[bI].price
        //     } 
        //     return vTotal
        // }
        // function countPrice (total, curPrice) {
        //    return total += curPrice.price;
        // }
        function renderPrice(paramFoodsArr) {
            var vTotal = paramFoodsArr.reduce(function(total, curPrice) {
                return total += curPrice.price;
            },0)
            return vTotal
        }


        function callApiToGetOrderList() {
            $.ajax({
                url: gBASE_URL + "/orders/",
                type: "GET",
                success: function (paramRes) {
                    console.log(paramRes);
                    loadUserListToTable(paramRes)
                },
                error: function (paramError) {
                    console.log(paramError.responseText)
                }
            });
        };
        function loadUserListToTable(paramOrderObj) {
            gOderDataTable.clear(),
                gOderDataTable.rows.add(paramOrderObj),
                gOderDataTable.draw()
        }
    });
</script>

</html>